USE HashMatch;
GO

-- Again the same query, now changed to be a Left Outer Join.

-- The start of the output is the same as for an Inner Join;
-- all the non-matched columns from the build are produced last, in "random" order.
WITH BuildTop AS
   (SELECT TOP (100) *
    FROM        dbo.BuildInput
    ORDER BY    Key1, Key2)
, ProbeTop AS
   (SELECT TOP (100) *
    FROM        dbo.ProbeInput
    ORDER BY    Key1, Key2)
SELECT      b.Key1, b.Key2, p.Key1, p.Key2
FROM        BuildTop AS b
LEFT  JOIN  ProbeTop AS p
      ON    b.Key1 = p.Key1
      AND   b.Key2 = p.Key2
OPTION (HASH JOIN, FORCE ORDER, MAXDOP 1);


-- As expected, a Full Outer Join behaves as Right and Left combined.
WITH BuildTop AS
   (SELECT TOP (100) *
    FROM        dbo.BuildInput
    ORDER BY    Key1, Key2)
, ProbeTop AS
   (SELECT TOP (100) *
    FROM        dbo.ProbeInput
    ORDER BY    Key1, Key2)
SELECT      b.Key1, b.Key2, p.Key1, p.Key2
FROM        BuildTop AS b
FULL  JOIN  ProbeTop AS p
      ON    b.Key1 = p.Key1
      AND   b.Key2 = p.Key2
OPTION (HASH JOIN, FORCE ORDER, MAXDOP 1);
