USE ContosoRetailDW;
GO

-- Scalar Aggregate
SELECT      MIN(fos.TotalCost * dc.YearlyIncome)
FROM        dbo.FactOnlineSales AS fos
INNER JOIN  dbo.DimCustomer AS dc
      ON    dc.CustomerKey = fos.CustomerKey;
GO

-- Partial Aggregate

-- (Use compatibility mode 120 to prevent scalar aggregate optimization)
ALTER DATABASE ContosoRetailDW SET COMPATIBILITY_LEVEL = 120;
GO

SELECT      MIN(fos.TotalCost * dc.YearlyIncome)
FROM        dbo.FactOnlineSales AS fos
INNER JOIN  dbo.DimCustomer AS dc
      ON    dc.CustomerKey = fos.CustomerKey;
GO

-- Reset compatibility level to 130
ALTER DATABASE ContosoRetailDW SET COMPATIBILITY_LEVEL = 130;
GO
