USE HashMatch;
GO

WITH Build1 AS
   (SELECT TOP (1000) *
    FROM        dbo.BuildInput
    ORDER BY    Key1, Key2)
, Probe1 AS
   (SELECT TOP (1000) *
    FROM        dbo.ProbeInput
    ORDER BY    Key1, Key2)
, Join1 AS
   (SELECT      b.Key1, p.Key2
    FROM        Build1 AS b
    INNER JOIN  Probe1 AS p
          ON    p.Key1 = b.Key1)
, Build2 AS
   (SELECT TOP (1000) *
    FROM        dbo.BuildInput
    ORDER BY    Key1 DESC, Key2 DESC)
, Probe2 AS
   (SELECT TOP (1000) *
    FROM        dbo.ProbeInput
    ORDER BY    Key1 DESC, Key2 DESC)
, Join2 AS
   (SELECT      p.Key1, b.Key2
    FROM        Build1 AS b
    INNER JOIN  Probe1 AS p
          ON    p.Key2 = b.Key2)
SELECT      b.Key2, MAX(p.Key1)
FROM        Join1 AS b
INNER JOIN  Join2 AS p
      ON    p.Key1 = b.Key1
      AND   p.Key2 = b.Key2
GROUP BY    b.Key2
OPTION (HASH JOIN, FORCE ORDER, MAXDOP 1); 
